GenericPatternCache (Jakarta-ORO 2.0.8 API)
Keywords: org.apache.oro.text.GenericPatternCache class

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.oro.text
Class GenericPatternCache

    java.lang.Object
      org.apache.oro.text.GenericPatternCache

All Implemented Interfaces:
  PatternCache

Direct Known Subclasses:
  PatternCacheFIFO, PatternCacheFIFO2, PatternCacheLRU, PatternCacheRandom

public abstract class GenericPatternCache
extends java.lang.Object
implements PatternCache

This is the base class for all cache implementations provided in the org.apache.oro.text package. Although 4 subclasses of GenericPatternCache are provided with this package, users may not derive subclasses from this class. Rather, users should create their own implmentations of the `PatternCache` interface.

Since:
  1.0
Version:
  2.0.8
See Also:
  `PatternCache`, `PatternCacheLRU`, `PatternCacheFIFO`, `PatternCacheFIFO2`, `PatternCacheRandom`

Field Summary
`static int` | `DEFAULT_CAPACITY` The default capacity to be used by the GenericPatternCache subclasses provided with this package.

Method Summary
`Pattern` | `addPattern(java.lang.String expression)` Same as calling
`Pattern` | `addPattern(java.lang.String expression, int options)` Adds a pattern to the cache and returns the compiled pattern.
`int` | `capacity()` Returns the maximum number of patterns that can be cached at one time.
`Pattern` | `getPattern(java.lang.String expression)` Same as calling
`Pattern` | `getPattern(java.lang.String expression, int options)` This method fetches a pattern from the cache.
`int` | `size()` Returns the number of elements in the cache, not to be confused with the `capacity()` which returns the number of elements that can be held in the cache at one time.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEFAULT_CAPACITY

    public static final int DEFAULT_CAPACITY

  The default capacity to be used by the GenericPatternCache subclasses provided with this package. Its value is 20.

  See Also:
    Constant Field Values

Method Detail

### addPattern

    public final Pattern addPattern(java.lang.String expression,
                                    int options)
                             throws MalformedPatternException

  Adds a pattern to the cache and returns the compiled pattern. This method is in principle almost identical to `getPattern()` except for the fact that it throws a MalformedPatternException if an expression cannot be compiled.

  addPattern() is meant to be used when you expressly intend to add an expression to the cache and is useful for front-loading a cache with expressions before use. If the expression added does not already exist in the cache, it is compiled, added to the cache, and returned. If the compiled expression is already in the cache, it is simply returned.

  The expected behavior of this method should be to start replacing patterns in the cache only after the cache has been filled to capacity.

  Specified by:
    `addPattern` in interface `PatternCache`
  Parameters:
    `expression` - The regular expression to add to the cache.
    `options` - The compilation options to use when compiling the expression.
  Returns:
    The Pattern corresponding to the String representation of the regular expression.
  Throws:
    `MalformedPatternException` - If there is an error in compiling the regular expression.

### addPattern

    public final Pattern addPattern(java.lang.String expression)
                             throws MalformedPatternException

  Same as calling

  >      addPattern(expression, 0);

  Specified by:
    `addPattern` in interface `PatternCache`
  Parameters:
    `expression` - The regular expression to add to the cache.
  Returns:
    The Pattern corresponding to the String representation of the regular expression.
  Throws:
    `MalformedPatternException` - If there is an error in compiling the regular expression.

### getPattern

    public final Pattern getPattern(java.lang.String expression,
                                    int options)
                             throws MalformedCachePatternException

  This method fetches a pattern from the cache. It is nearly identical to `addPattern()` except that it doesn't throw a MalformedPatternException. If the pattern is not in the cache, it is compiled, placed in the cache, and returned. If the pattern cannot be compiled successfully, it throws a MalformedCachePatternException. Note that this exception is derived from RuntimeException, which means you are NOT forced to catch it by the compiler. Please refer to `MalformedCachePatternException` for a discussion of when you should and shouldn't catch this exception.

  Specified by:
    `getPattern` in interface `PatternCache`
  Parameters:
    `expression` - The regular expression to fetch from the cache in compiled form.
    `options` - The compilation options to use when compiling the expression.
  Returns:
    The Pattern corresponding to the String representation of the regular expression.
  Throws:
    `MalformedCachePatternException` - If there is an error in compiling the regular expression.

### getPattern

    public final Pattern getPattern(java.lang.String expression)
                             throws MalformedCachePatternException

  Same as calling

  >      getPattern(expression, 0)

  Specified by:
    `getPattern` in interface `PatternCache`
  Parameters:
    `expression` - The regular expression to fetch from the cache in compiled form.
  Returns:
    The Pattern corresponding to the String representation of the regular expression.
  Throws:
    `MalformedCachePatternException` - If there is an error in compiling the regular expression.

### size

    public final int size()

  Returns the number of elements in the cache, not to be confused with the `capacity()` which returns the number of elements that can be held in the cache at one time.

  Specified by:
    `size` in interface `PatternCache`
  Returns:
    The current size of the cache (i.e., the number of elements currently cached).

### capacity

    public final int capacity()

  Returns the maximum number of patterns that can be cached at one time.

  Specified by:
    `capacity` in interface `PatternCache`
  Returns:
    The maximum number of patterns that can be cached at one time.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright ? 2000-2003 Apache Software Foundation. All Rights Reserved.